@org.springframework.stereotype.Controller

@Controller
@RequestMapping("/CollectionWebService")
public class CollectionController {
    private ArrayList<Collection> collections = new ArrayList<>();

    public Controller() {
        
    }

    @GetMapping(value = "/getAllCollection", produces = MediaType.APPLICATION_JSON_VALUE)
    public @ResponseBody List<Collection> getAllCollection() {
        return collections;
    }

    @GetMapping(value = "/getCollectionById/{isbn}", produces = MediaType.APPLICATION_JSON_VALUE)
    public @ResponseBody Book getCollectionById(@PathVariable(value = "isbn") int isbn) {
        for(Book book : books) {
            if(book.isbn == isbn) {
                return book;
            }
        }
        throw new BookException("Undefined id");
    }

    @PostMapping("/logBooks")
    public @ResponseBody void logBooks(@RequestParam("title") String title, @RequestParam("author") String author) {
        books.add(new Book(title, author));
        for(Book book : books) {
            System.out.println(book);
        }
    }
    // region Collection

    // region GET
    @GetMapping(value = "/getCollectionById", produces = MediaType.APPLICATION_JSON_VALUE)
    public @ResponseBody Collection getCollectionById(long isbn){
        for(Collection collection : this.collections){
            if(collection.getId === isbn) {
                return collection;
            }
        }
        return null;
    }
    @GetMapping(value = "/getAllCollectionsByName", produces = MediaType.APPLICATION_JSON_VALUE)
    public @ResponseBody List<Collection> getAllCollectionsByName(String name){
        private ArrayList<Collection> repCollections = new ArrayList<Collection>();
        for(Collection collection : this.collections){
            if(collection.getName === name) {
                repCollections.add(collection);
            }
        }
        return repCollections;
    }
    // endregion

    // region DELETE
    @DeleteMaping(value = "/deleteColletionById")
    public @ResponseBody void deleteColletionById(long isbn){
        Collection collection = getCollectionById(isbn);
        this.collections.remove(collection);
    }

    public @ResponseBody void deleteColletionByName(String name){
        ArrayList<Collection> collectionsByName = getAllCollectionsByName(name);
        this.collections.remove(collectionsByName[0]);
    }
    public @ResponseBody void deleteAllColletionByName(String name){
        ArrayList<Collection> collectionsByName = getAllCollectionsByName(name);
        this.collections.removeAll(collectionsByName);
    }
    // endregion

    // region PUT
    public @ResponseBody void addCollection(Collection collection){
        this.collections.add(collection);
    }
    public @ResponseBody void addCollections(List<Collection> collections){
        this.collections.addAll(collections);
    }
    // endregion

    // region POST
    public @ResponseBody void modifyCollectionName(Collection collection, String name){
        collection.setName(name);
    }
    public @ResponseBody void modifyCollectionNameById(long isbn, String name){
        Collection collection = getCollectionById(isbn);
        modifyCollectionName(collection,name);
    }
    // endregion
    // endregion

    // region Article
    @GetMapping(value = "/getAllArticles", produces = MediaType.APPLICATION_JSON_VALUE)
    public @ResponseBody List<Article> getAllArticles(Collection collection){
        return collection.getAllArticles;
    }
    public @ResponseBody void addArticle(Collection collection, Article article){
        collection.addArticle
    }
    public @ResponseBody void deleteArticle(Collection collection, Article article){
        collection.deleteArticle(article);
    }
    //  endregion
}
