package SAE.ApiREST.WebService.service;

import java.sql.Date;
import java.util.ArrayList;
import java.util.List;

import org.springframework.stereotype.Service;

import SAE.ApiREST.WebService.model.Article;

@Service
public class CollectionService implements ICollectionService {
    private ArrayList<Collection> collections;
    public List<Collection> getAllCollections() {
        return this.collections;
    }

    // region Collection

    // region GET
    public Collection getCollectionById(long isbn){
        for(Collection collection : this.collections){
            if(collection.getId === isbn) {
                return collection;
            }
        }
        return null;
    }
    public List<Collection> getAllCollectionsByName(String name){
        private ArrayList<Collection> repCollections = new ArrayList<Collection>();
        for(Collection collection : this.collections){
            if(collection.getName === name) {
                repCollections.add(collection);
            }
        }
        return repCollections;
    }
    // endregion

    // region DELETE
    public void deleteColletionById(long isbn){
        Collection collection = getCollectionById(isbn);
        this.collections.remove(collection);
    }

    public void deleteColletionByName(String name){
        ArrayList<Collection> collectionsByName = getAllCollectionsByName(name);
        this.collections.remove(collectionsByName[0]);
    }
    public void deleteAllColletionByName(String name){
        ArrayList<Collection> collectionsByName = getAllCollectionsByName(name);
        this.collections.removeAll(collectionsByName);
    }
    // endregion

    // region PUT
    public void addCollection(Collection collection){
        this.collections.add(collection);
    }
    public void addCollections(List<Collection> collections){
        this.collections.addAll(collections);
    }
    // endregion

    // region POST
    public void modifyCollectionName(Collection collection, String name){
        collection.setName(name);
    }
    public void modifyCollectionNameById(long isbn, String name){
        Collection collection = getCollectionById(isbn);
        modifyCollectionName(collection,name);
    }
    // endregion
    // endregion

    // region Article
    public List<Article> getAllArticles(Collection collection){
        return collection.getAllArticles;
    }
    public void addArticle(Collection collection, Article article){
        collection.addArticle
    }
    public void deleteArticle(Collection collection, Article article){
        collection.deleteArticle(article);
    }
    //  endregion
}